
uniform sampler2D tex0,tex1,envMap;

void main (void)
{
    vec4 col = texture2D(tex0, vec2(gl_TexCoord[0]));
    
    vec3 R = gl_TexCoord[2].xyz;
    float ex = ((R.x + R.z) + 1.415) / 2.83;
    if (R.x > R.z) ex = 1.0 - ex;
    vec4 colenv = texture2D(envMap, vec2(ex, R.y)) * 0.8;
    
    float dirt = 1.0 - texture2D(tex1, vec2(gl_TexCoord[0])).x;
    col *= gl_Color + vec4(0.2, 0.2, 0.2, 1.0);
    col = col * 2.0;

    col.xyz = mix(col.xyz, colenv.xyz, vec3(0.3));
    col.xyz = mix(col.xyz, vec3(0.18,0.1,0.04), vec3(dirt));
    col.w = 1.0;

    gl_FragColor = col;
}
