
uniform mat4 mWorldViewProj;
uniform mat4 mInvWorld;
uniform mat4 mTransWorld;
uniform vec3 mLightPos;
uniform vec3 eyePosition;
uniform vec4 mLightColor;

void main(void)
{
	gl_Position = mWorldViewProj * gl_Vertex;
	
	vec4 normal = vec4(gl_Normal, 0.0);
        normal.z = -normal.z;
	normal = mInvWorld * normal;
        normal.z = -normal.z;
	normal = normalize(normal);
	
	vec4 worldpos = gl_Vertex * mTransWorld;
	
	vec4 lightVector = vec4(0.0, 0.0, 0.0, 0.0) - vec4(mLightPos,1.0);
	lightVector = normalize(lightVector);
	
	float tmp2 = dot(-lightVector, normal);
	
	vec4 tmp = mLightColor * tmp2;
	gl_FrontColor = gl_BackColor = vec4(tmp.x, tmp.y, tmp.z, 0.0);
	
	gl_TexCoord[0] = gl_MultiTexCoord0;
	gl_TexCoord[1] = gl_MultiTexCoord1;
	
	vec3 I = worldpos.xyz - eyePosition;
//	vec3 tmp3;
//	tmp3.x = dot(normal.xyz, I);
//	tmp3 = normal.xyz * tmp3.x * 2.0;
	
//	gl_TexCoord[2].xyz = I - tmp3;
	gl_TexCoord[2].xyz = normalize(I - 2.0 * normal.xyz * dot(normal.xyz, I));
	gl_TexCoord[2].xz = normalize(gl_TexCoord[2].xz);
	gl_TexCoord[2].y = (gl_TexCoord[2].y * -0.5) + 0.5;
}
